/*
		    TTTTTTT    OOOOO    7777777
		       T      O     O        7
		       T      O     O       7
		       T      O     O      7
		       T      O     O     7
		       T       OOOOO     7

			     EMULATEUR

			  Par Sylvain HUET
		(sylvain.huet@polytechnique.org)
				  1994-2002
	
	  main.c : routine windows de l'emulateur
	  
*/
#include <windows.h>
#include <windowsx.h>
#include <wingdi.h>
#include <commctrl.h>
#include <commdlg.h>
#include <string.h>

#include "resource.h"
#include "main.h"
#include "emuto7.h"
#include "monitor.h"
#include "video.h"
#include "sound.h"
#include "harddisplay.h"

int widthTO=200;
int heightTO=320;

HWND TOhwnd;

#ifdef TO770
TCHAR *title=TEXT("FunzyTO7-70");
#else
TCHAR *title=TEXT("FunzyTO7");
#endif

HBITMAP hkeybd;
HBITMAP hkeybdsh;

int flagshift=0;
int flagbutton=0;

int merge(LPTSTR name,long k);
void newcass(LPTSTR c);



void TOrepaint()
{
	
    HDC Dcw , Dcb ;       
    HBITMAP OldBitmap ;
	PAINTSTRUCT ps;
	long i;

	Dcw=BeginPaint(TOhwnd,&ps);
    Dcb=CreateCompatibleDC(Dcw);
//	OldBitmap = SelectObject(Dcb, TObmp);
//	BitBlt ( Dcw, 0, 0, widthTO, heightTO, Dcb, 0, 0, SRCCOPY);
	if (!flagshift)	OldBitmap = SelectObject(Dcb, hkeybd);
	else OldBitmap = SelectObject(Dcb, hkeybdsh);
	BitBlt ( Dcw, 200, 0, 40, 320, Dcb, 0, 0, SRCCOPY);
	SelectObject ( Dcb , OldBitmap ) ;
	DeleteDC ( Dcb ) ;
	EndPaint(TOhwnd,&ps);

	if (isemurunning()) for(i=0x4000;i<0x5f40;i++) affcur(i);
}

int oldflagsh=-1;

void TOredraw()
{
    HDC Dcw , Dcb ;       
    HBITMAP OldBitmap ;

	Dcw=GetDC(TOhwnd);
	if (oldflagsh!=flagshift)
	{
		oldflagsh=flagshift;
		Dcb=CreateCompatibleDC(Dcw);
		if (!flagshift)	OldBitmap = SelectObject(Dcb, hkeybd);
		else OldBitmap = SelectObject(Dcb, hkeybdsh);
		BitBlt ( Dcw, 200, 0, 40, 320, Dcb, 0, 0, SRCCOPY);
		SelectObject ( Dcb , OldBitmap ) ;
		DeleteDC ( Dcb ) ;
	}
	DeleteDC ( Dcw ) ;

}

void TOredrawall()
{
	long i;

	for(i=0x4000;i<0x5f40;i++) affcur(i);
	oldflagsh=-1;
	TOredraw();
}

int openmemo7()
{
	OPENFILENAME ofn;
	TCHAR buff[MAX_PATH]= TEXT("\0");
   
	stopemu();
	stophard();

	memset( &(ofn), 0, sizeof(ofn));
	ofn.lStructSize   = sizeof(ofn);
	ofn.hwndOwner         = TOhwnd ;
	ofn.lpstrFile         = buff ; 
	ofn.nMaxFile          = MAX_PATH ;
	ofn.lpstrFilter = TEXT("Memo7 (*.m7)\0*.m7\0");   
	ofn.lpstrTitle = TEXT("Open Memo7");
	ofn.Flags = OFN_EXPLORER;

	if (GetOpenFileName (&ofn))
	{
		merge(buff,0);
		reset();
	}
	gohard(TOhwnd);
	launchemu();
	TOredrawall();
	return 0;
}

int openk7()
{
	OPENFILENAME ofn;
	TCHAR buff[MAX_PATH]= TEXT("\0");
   
	stopemu();
	stophard();

	memset( &(ofn), 0, sizeof(ofn));
	ofn.lStructSize   = sizeof(ofn);
	ofn.hwndOwner         = TOhwnd ;
	ofn.lpstrFile         = buff ; 
	ofn.nMaxFile          = MAX_PATH ;
	ofn.lpstrFilter = TEXT("K7 (*.k7)\0*.k7\0");   
	ofn.lpstrTitle = TEXT("Open K7");
	ofn.Flags = OFN_EXPLORER;

	if (GetOpenFileName (&ofn))
	{
		newcass(buff);
	}
	gohard(TOhwnd);
	launchemu();
	TOredrawall();
	return 0;
}

int movemouse(int x,int y)
{
	updatecray(heightTO-1-y,x);
	return 0;
}

int key(int val,int state)
{
	if (state) newkeydown(val);
	else newkeyup(val);
	return 0;
}

int keybdchg(int x,int y,int state)
{
	if (x>=237)
	{
		if (x>=279)
		{
			if (y<=12) PostQuitMessage(0);
			else if (y<=26)
			{
				if (isemurunning()) stopemu();
				else launchemu();
			}
			else
			{
				avanck7(0);
				reset();
			}
		}
		else
		{
			if (y<=12) openk7();
			else if (y<=26) openmemo7();
			else
			{
				stopemu();
				stophard();
				MessageBox(TOhwnd,TEXT("FunzyTO7-ce\n\npar Sylvain HUET\n\n2002, V2.0"),TEXT("FunzyTO7"),MB_OK);
				gohard(TOhwnd);
				launchemu();
				TOredrawall();
			}
		}
	}
	else if (x<=191)
	{
		if (y<10)
		{
			if (x<12) key(0x1b,state);
			else if (x<24) key(0x31,state);
			else if (x<36) key(0x32,state);
			else if (x<48) key(0x33,state);
			else if (x<60) key(0x34,state);
			else if (x<72) key(0x35,state);
			else if (x<84) key(0x36,state);
			else if (x<96) key(0x37,state);
			else if (x<108) key(0x38,state);
			else if (x<120) key(0x39,state);
			else if (x<132) key(0x30,state);
			else if (x<144) key(0xdb,state);
			else if (x<156) key(0xbb,state);
			else if (x<168) key(0x09,state);
			else if (x<180) key(0x26,state);
			else key(0x28,state);
		}
		else if (y<20)
		{
			if (x<12) key(0x11,state);
			else if (x<31) key(0x41,state);
			else if (x<43) key(0x5a,state);
			else if (x<55) key(0x45,state);
			else if (x<67) key(0x52,state);
			else if (x<79) key(0x54,state);
			else if (x<91) key(0x59,state);
			else if (x<103) key(0x55,state);
			else if (x<115) key(0x49,state);
			else if (x<127) key(0x4f,state);
			else if (x<139) key(0x50,state);
			else if (x<151) key(0xbf,state);
			else if (x<168) key(0xdf,state);
			else if (x<180) key(0x25,state);
			else key(0x27,state);
		}
		else if (y<30)
		{
			if (x<12) key(0xde,state);
			else if (x<36) key(0x51,state);
			else if (x<48) key(0x53,state);
			else if (x<60) key(0x44,state);
			else if (x<72) key(0x46,state);
			else if (x<84) key(0x47,state);
			else if (x<96) key(0x48,state);
			else if (x<108) key(0x4a,state);
			else if (x<120) key(0x4b,state);
			else if (x<132) key(0x4c,state);
			else if (x<144) key(0x4d,state);
			else if (x<168) key(0x0d,state);
			else key(0x01,state);

		}
		else
		{
			if (x<31)
			{
				flagshift=1-flagshift;
				key(0x10,flagshift);
			}
			else if (x<43) key(0x57,state);
			else if (x<55) key(0x58,state);
			else if (x<67) key(0x43,state);
			else if (x<79) key(0x56,state);
			else if (x<91) key(0x42,state);
			else if (x<103) key(0x4e,state);
			else if (x<115) key(0xbc,state);
			else if (x<127) key(0xbe,state);
			else if (x<139) key(0xc0,state);
			else if (x<168) key(0x20,state);
			else if (x<180) key(0x2d,state);
			else key(0x2e,state);
		}
	}
	return 0;
}

int clickmouse(int x,int y,int state)
{
	movemouse(x,y);
	updatecraypoint(state);
	if ((x>=widthTO)&&(state==1))
	{
		keybdchg(heightTO-1-y,x-widthTO,state);
	}
	if (state==0)
	{
		resetkey();
		if (flagshift) newkeydown(0x10);
	}

	return 0;
}

LRESULT CALLBACK WindowProc( HWND hwnd, unsigned msg,
							UINT wParam, LONG lParam )
{
    switch( msg ) {
		
    case WM_DESTROY:
		if (isemurunning()) stopemu();
		stophard();
		StopSound();
		PostQuitMessage(0);
		break;
    case WM_PAINT:
		TOrepaint();
        break;
    case WM_MOUSEMOVE :
		movemouse(LOWORD(lParam),HIWORD(lParam));
        break;
    case WM_LBUTTONDOWN :
		flagbutton=1;
		clickmouse(LOWORD(lParam),HIWORD(lParam),1);
		break;
    case WM_LBUTTONUP :
		flagbutton=0;
		clickmouse(LOWORD(lParam),HIWORD(lParam),0);
		break;
	case MM_WOM_DONE:
		SoundPlayEvent((int)hwnd,(int)msg,(int)wParam,(int)lParam);
		BeginSoundBuffer();
		if ((ifSoundOn())&&(isemurunning())) runemu();
		FinishSoundBuffer();

		break;
		
    default:
        return( DefWindowProc( hwnd, msg, wParam, lParam ) );
    }
	
	//    return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	
	return 0;
}

#define FlagMainWindow (WS_VISIBLE)

int TOinitWindow(HANDLE this_inst,int cmdshow)
{
	TCHAR buf[256];

	TOhwnd =  CreateWindow(TEXT("GenericClass"),title, FlagMainWindow,
        0,0,240,320,
		NULL,NULL,this_inst,NULL);

	if (!TOhwnd)
	{
		wsprintf(buf,TEXT("%d"),GetLastError());
		MessageBox(NULL,TEXT("window error"),buf,MB_OK);
		return -1;
	}
//	MessageBox(NULL,TEXT("window ok"),TEXT("x"),MB_OK);
    
    ShowWindow(TOhwnd,cmdshow);
    UpdateWindow(TOhwnd);
	return 0;
}



static BOOL AnyInstance( HANDLE this_inst, HANDLE prev_inst, int cmdshow, LPTSTR cmdline )
{
	hkeybd=LoadBitmap(this_inst,MAKEINTRESOURCE(IDB_BITMAP1));
	hkeybdsh=LoadBitmap(this_inst,MAKEINTRESOURCE(IDB_BITMAP2));

	if (TOinitWindow(this_inst,cmdshow)) return FALSE;

	if (gohard(TOhwnd))
	{
		MessageBox(TOhwnd,TEXT("impossible d'ouvrir l'cran"),TEXT("alert!"),MB_OK);
		return FALSE;
	}

	initemu();
	launchemu();
	StartSound();
    return TRUE;                       
}

static BOOL FirstInstance( HANDLE this_inst )
{
    WNDCLASS    wc;
    BOOL        rc;
	
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = (LPVOID) WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = this_inst;
    wc.hIcon = 0;
    wc.hCursor = 0;
    wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = 0;
    wc.lpszClassName = TEXT("GenericClass");
    rc = RegisterClass( &wc );
	
    return( rc );
}

int WINAPI WinMain( HINSTANCE this_inst, HINSTANCE prev_inst, LPTSTR cmdline,
				   int cmdshow)
{
	MSG         msg;

	if( !FirstInstance( this_inst ) )
	{
		MessageBox(NULL,TEXT("Class error"),TEXT("x"),MB_OK);
		return( FALSE );
	}
    if( !AnyInstance( this_inst, prev_inst, cmdshow, cmdline ) ) return( FALSE );
	
	
	while(1)
	{
		if ( GetMessage( &msg, NULL, 0, 0 ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else return ( msg.wParam );
	}
    return 0;
}


